import "core-js/modules/es.string.replace";
import React from 'react';
import { connect } from 'react-redux';
import { replace } from '../actions';
import PropTypes from 'prop-types';
export class Match extends React.Component {
  render() {
    var {
      children,
      isMatch,
      isAuthenticate
    } = this.props;
    return isMatch && isAuthenticate && React.Children.only(children) || null;
  }

  componentDidMount() {
    if (!this.props.isAuthenticate && this.props.isMatch) {
      this.props.replace(this.props.redirect);
    }
  }

  componentDidUpdate(prevProps, prevState) {
    if (!this.props.isAuthenticate && this.props.isMatch) {
      this.props.replace(this.props.redirect);
    }
  }

}
Match.propTypes = {
  children: PropTypes.element,
  isMatch: PropTypes.bool,
  isAuthenticate: PropTypes.bool,
  replace: PropTypes.func,
  redirect: PropTypes.func
};
/* eslint-disable */

Match = connect((state, props) => {
  var isMatch;

  if (Array.isArray(props.name)) {
    var names = props.name;
    isMatch = names.some(name => {
      var url = state.routing.urls[name];

      if (url) {
        return props.isExactly && url.match == 2 || !props.isExactly && url.match;
      }

      return false;
    });
  } else {
    var url = state.routing.urls[props.name];

    if (url) {
      isMatch = props.isExactly && url.match == 2 || !props.isExactly && url.match;
    } else {
      isMatch = false;
    }
  }

  return {
    isMatch,
    isAuthenticate: props.checkAuthenticate ? props.checkAuthenticate(state) : true
  };
}, {
  replace
})(Match);
/* eslint-disable */

Match.defaultProps = {
  isExactly: false
};