"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.routerActions = exports.unblock = exports.block = exports.goBack = exports.replace = exports.push = void 0;

var _constants = require("./constants");

var historyAction = function historyAction(action) {
  return function (location) {
    return {
      type: _constants.URL_CHANGE,
      data: {
        location: Object.assign({}, location, {
          action: action
        })
      }
    };
  };
};

var push = historyAction('push');
exports.push = push;
var replace = historyAction('replace'); //export const go = historyAction('go') //not check

exports.replace = replace;
var goBack = historyAction('goBack'); //export const goForward = historyAction('goForward') //not check

exports.goBack = goBack;

var block = function block() {
  var msg = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  return {
    type: _constants.URL_CHANGE_BLOCK,
    data: {
      msg: msg
    }
  };
};

exports.block = block;

var unblock = function unblock() {
  return {
    type: _constants.URL_CHANGE_UNBLOCK
  };
};

exports.unblock = unblock;
var routerActions = {
  push: push,
  replace: replace,
  block: block,
  unblock: unblock
  /*, go, goBack, goForward*/

};
exports.routerActions = routerActions;