"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Link = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactRedux = require("react-redux");

var _actions = require("../actions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Link = /*#__PURE__*/function (_React$Component) {
  _inherits(Link, _React$Component);

  var _super = _createSuper(Link);

  function Link(props) {
    var _this;

    _classCallCheck(this, Link);

    _this = _super.call(this, props);
    _this.onClick = _this.onClick.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Link, [{
    key: "onClick",
    value: function onClick(e) {
      var _this$props = this.props,
          push = _this$props.push,
          replace = _this$props.replace,
          action = _this$props.action,
          pathname = _this$props.pathname,
          state = _this$props.state,
          query = _this$props.query;

      if (!this.props.isReload) {
        e.preventDefault();

        if (action == 'PUSH') {
          this.props.push({
            pathname: pathname,
            state: state,
            query: query
          });
        } else if (action == 'REPLACE') {
          replace({
            pathname: pathname,
            state: state,
            query: query
          });
        }
      } //var {name,params,query,state,action} = this.props;
      //this.context.action(name,params,query,state,action)

    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          children = _this$props2.children,
          href = _this$props2.href,
          isActive = _this$props2.isActive,
          _this$props2$isReload = _this$props2.isReload,
          isReload = _this$props2$isReload === void 0 ? false : _this$props2$isReload;
      return /*#__PURE__*/_react["default"].createElement('a', {
        href: href,
        onClick: this.onClick,
        className: isActive ? 'active' : ''
      }, children);
    }
  }]);

  return Link;
}(_react["default"].Component);

exports.Link = Link;
Link.propTypes = {
  push: _propTypes["default"].func,
  replace: _propTypes["default"].func,
  action: _propTypes["default"].object,
  pathname: _propTypes["default"].string,
  state: _propTypes["default"].object,
  query: _propTypes["default"].string,
  isReload: _propTypes["default"].bool,
  children: _propTypes["default"].element,
  href: _propTypes["default"].string,
  isActive: _propTypes["default"].bool
};
Link.defaultProps = {
  isReload: false,
  action: 'PUSH'
};
Link.contextTypes = {
  action: _propTypes["default"].func
};
/*eslint-disable */

exports.Link = Link = (0, _reactRedux.connect)(function (state, props) {
  var _state$routing = state.routing,
      paramMap = _state$routing.paramMap,
      urls = _state$routing.urls,
      location = _state$routing.location;
  var url = urls[props.name];
  var tokens = url.tokens;
  var href = tokens.reduce(function (result, next) {
    if (!next.startsWith(':')) result += next;else {
      var key = next.substring(1);
      result += props.params && props.params[key] || paramMap[key];
    }
    return result;
  }, '');

  function jsonToQueryString(json) {
    return '?' + Object.keys(json).map(function (key) {
      return encodeURIComponent(key) + '=' + encodeURIComponent(json[key]);
    }).join('&');
  }

  var qStr = jsonToQueryString(props.query || {});
  return {
    pathname: href,
    href: href + qStr,
    isActive: href == location.pathname
  };
}, {
  push: _actions.push,
  replace: _actions.replace
})(Link);
/* eslint-disable */